#pragma once

#include <vector>
#include <unordered_map>

#include "Decay.hh"

namespace HEJFOG{
  struct ParticleProperties{
    double mass;
    double width;
    std::vector<Decay> decays;
  };
  #if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ < 6)
  // gcc version < 6 explicitly needs hash function for enum
  // see https://gcc.gnu.org/bugzilla/show_bug.cgi?id=60970
  using ParticlesPropMap
    = std::unordered_map<HEJ::ParticleID, ParticleProperties, std::hash<int>>;
  #else
  using ParticlesPropMap
    = std::unordered_map<HEJ::ParticleID, ParticleProperties>;
  #endif
}
