#pragma once

#include "yaml-cpp/yaml.h"

#include "HEJ/HiggsCouplingSettings.hh"
#include "HEJ/optional.hh"
#include "HEJ/config.hh"
#include "HEJ/output_formats.hh"
#include "HEJ/exceptions.hh"

#include "Process.hh"
#include "JetParameters.hh"
#include "Beam.hh"
#include "ParticleProperties.hh"
#include "UnweightSettings.hh"

namespace HEJFOG{

  struct Config{
    Process process;
    int events;
    JetParameters jets;
    Beam beam;
    int pdf_id;
    double subleading_fraction;
    unsigned int subleading_channels; //! < see HEJFOG::Subleading
    ParticlesPropMap particles_properties;
    YAML::Node analysis_parameters;
    HEJ::ScaleConfig scales;
    std::vector<HEJ::OutputFile> output;
    HEJ::RNGConfig rng;
    HEJ::HiggsCouplingSettings Higgs_coupling;
    HEJ::optional<UnweightSettings> unweight;
  };

  Config load_config(std::string const & config_file);

}
