#include <iostream>
#include <stdexcept>

#include "HepMC/ReaderAscii.h"

static constexpr double ep = 1e-3;

int main(int argn, char** argv) {
  if(argn != 2){
    std::cerr << "Usage: check_hepmc hepmc_file\n";
    return EXIT_FAILURE;
  }

  HepMC::ReaderAscii input{argv[1]};
  if(input.failed()) throw std::runtime_error{"failed to open HepMC file"};
  while(true){
    HepMC::GenEvent ev{};
    if ( !input.read_event(ev) || ev.event_number() == 0 ) break;
    if(input.failed()) throw std::runtime_error{"failed to read HepMC event"};
  }
}
