#include <iostream>

#include "HEJ/stream.hh"
#include "LHEF/LHEF.h"

static constexpr double ep = 1e-3;

int main(int argn, char** argv) {
  if(argn != 2){
    std::cerr << "Usage: check_lhe lhe_file\n";
    return EXIT_FAILURE;
  }

  HEJ::istream in{argv[1]};
  LHEF::Reader reader{in};

  std::vector<double> xsec_ref(reader.heprup.NPRUP, 0.);
  while(reader.readEvent()){
    xsec_ref[reader.hepeup.IDPRUP-1] += reader.hepeup.weight();
  }

  for(size_t i = 0; i < xsec_ref.size(); ++i){
    std::cout << xsec_ref[i] << '\t' << reader.heprup.XSECUP[i] << '\n';
    if(std::abs(xsec_ref[i]/reader.heprup.XSECUP[i] - 1) > ep){
      std::cerr << "Cross sections deviate substantially";
      return EXIT_FAILURE;
    }
  }
}
