#include <stdexcept>
#include <iostream>

#include "HEJ/YAMLreader.hh"
#include "HEJ/Event.hh"

int main(int argc, char** argv) {
  constexpr double ep = 1e-7;
  if (argc != 2) {
    throw std::logic_error{"wrong number of args"};
  }
  const HEJ::Config config = HEJ::load_config(argv[1]);

  HEJ::UnclusteredEvent tmp;
  tmp.outgoing.push_back(
      {HEJ::ParticleID::gluon, fastjet::PtYPhiM(50., -1., 0.3, 0.)}
  );
  tmp.outgoing.push_back(
      {HEJ::ParticleID::gluon, fastjet::PtYPhiM(30., 1., -0.3, 0.)}
  );
  HEJ::Event ev{
    std::move(tmp),
    fastjet::JetDefinition{fastjet::kt_algorithm, 0.4},
    20.
  };

  const double softest_pt = config.scales.base[0](ev);
  if(std::abs(softest_pt-30.) > ep){
    throw std::logic_error{"wrong softest pt"};
  }
}
